• 周赛补题(AcWing、力扣)


    AcWing第66场周赛

    第一题:4606. 奇偶判断 - AcWing题库

    思路:对输入的字符串的最后一个字母进行判断即可。

    代码

    1. #include <bits/stdc++.h>
    2. using namespace std;
    3. int main()
    4. {
    5. ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    6. string s;
    7. cin >> s;
    8. reverse(s.begin(), s.end());
    9. if(s[0] - '0' & 1) cout << 1 << endl;
    10. else cout << 0 << endl;
    11. return 0;
    12. }

    第二题:4607. 字母补全 - AcWing题库

    思路:没看清楚题目,wa了一次。滑动窗口。当窗口大小(每个字母的次数最多为1,遇到?可以直接扩大窗口)大于26说明可以找到符合条件的字符串,将窗口的中的?转化为字母是窗口中的所有的大写的字母都恰出现一次,其余的?可以任意替换为一个大写的字母。

    代码

    1. #include <bits/stdc++.h>
    2. using namespace std;
    3. string s;
    4. int cnt[26], t[26];
    5. int main()
    6. {
    7. ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    8. cin >> s;
    9. bool st = 0;
    10. int b, e;
    11. for(int i = 0, j = 0; i < s.size(); i ++)
    12. {
    13. if(s[i] != '?')
    14. {
    15. cnt[s[i] - 'A'] ++;
    16. while(j < i && cnt[s[i] - 'A'] > 1) cnt[s[j ++] - 'A'] --;
    17. }
    18. if(i - j + 1 == 26)
    19. {
    20. st = 1;
    21. b = j, e = i;
    22. break;
    23. }
    24. }
    25. if(!st) cout << -1 << endl;
    26. else
    27. {
    28. for(int i = b; i <= e; i ++)
    29. if(s[i] != '?')
    30. t[s[i] - 'A'] = 1;
    31. for(int i = b, k = 0; i <= e; i ++)
    32. if(s[i] == '?')
    33. {
    34. while(k < 26 && t[k]) k ++;
    35. s[i] = (char)(k + 'A');
    36. k ++;
    37. }
    38. for(int i = 0; i < s.size(); i ++)
    39. if(s[i] == '?')
    40. s[i] = 'A';
    41. cout << s << endl;
    42. }
    43. return 0;
    44. }

    第三题:4608. 整数分组 - AcWing题库

    思路:将所有的数用哈希表存储,统计出现一次的数的个数cnt,当一个数出现的次数大于等于3时表示可以分出一个超级数出来res。

    为了使A和B中的超级数相同有两种情况:

            1、cnt为偶数,将前cnt/2个只出现一次的数给A,后cnt/2个只出现一次的数给B,其余的数给A或B都可以

            2、cnt为偶数,res>0,将前(cnt+1)/2个只出现一次的数给A,后cnt/2个只出现一次的数给B,可以从出现次数大于等于3的数x中分出一个超级数给B(有一个x给B,其余的x都要给A),其余的数给A或B都可以。

    这两种情况就直接模拟就可以了。

    代码

    1. #include <bits/stdc++.h>
    2. using namespace std;
    3. const int N = 110;
    4. int a[N];
    5. int n;
    6. unordered_map<int, int> mp;
    7. int main()
    8. {
    9. cin >> n;
    10. for(int i = 0; i < n; i ++)
    11. {
    12. cin >> a[i];
    13. mp[a[i]] ++;
    14. }
    15. int cnt = 0, res = 0;
    16. for(auto [x, y] : mp)
    17. {
    18. if(y == 1) cnt ++;
    19. else if(y > 2) res ++;
    20. }
    21. res = min(res, 1);
    22. if(cnt % 2 == 0) res = 0;
    23. if(cnt % 2 == 0 || res)
    24. {
    25. cout << "YES" << endl;
    26. string s;
    27. int ans = 0;
    28. for(int i = 0; i < n; i ++)
    29. {
    30. if(mp[a[i]] == 1)
    31. {
    32. ans ++;
    33. if(ans <= (cnt + 1) / 2) s += 'A';
    34. else s += 'B';
    35. }
    36. else if(mp[a[i]] > 2 && res)
    37. {
    38. s += 'B';
    39. res --;
    40. }
    41. else s += 'A';
    42. }
    43. cout << s << endl;
    44. }
    45. else cout << "NO" << endl;
    46. return 0;
    47. }

    力扣第308场周赛

    第一题:2389. 和有限的最长子序列 - 力扣(LeetCode)

    思路:求一个小于等于m子序列的最大长度,这个序列一定是都前n个最小的数组成的序列(这个应该很容易想到(OS :关于证明全搞完了,y总平时将证明的时候也没有好好听,而且好要证明充分性和必要性,有点麻烦))。所以可以先将数组排序求前缀和,对于每个询问找出对于小于等于该数的最大的前缀和的最大长度。

    代码

    1. class Solution {
    2. public:
    3. vector<int> answerQueries(vector<int>& nums, vector<int>& q) {
    4. sort(nums.begin(), nums.end());
    5. int n = nums.size();
    6. vector<int> s(n, 0);
    7. map<int, int> mp;
    8. for(int i = 0; i < n; i ++)
    9. {
    10. if(!i) s[i] = nums[i];
    11. else s[i] = s[i - 1] + nums[i];
    12. mp[s[i]] = i + 1;
    13. }
    14. vector<int> ans;
    15. for(auto i : q)
    16. {
    17. auto it = mp.upper_bound(i);
    18. if(it == mp.begin()) ans.push_back(0);
    19. else
    20. {
    21. it --;
    22. ans.push_back(it->second);
    23. }
    24. }
    25. return ans;
    26. }
    27. };

    第二题:2390. 从字符串中移除星号 - 力扣(LeetCode)

    思路:用栈来模拟。因为这个字符串会将*的最左边的非*的字符删除,所以可以用栈(先进先出)来模拟。遇到了一个*,如果当前栈不是空的话,栈顶元素一定是在*最左边的一个非*字符。

    代码

    1. class Solution {
    2. public:
    3. string removeStars(string s) {
    4. stack<char> str;
    5. for(int i = 0; i < s.size(); i ++)
    6. {
    7. if(s[i] == '*' && str.size()) str.pop();
    8. else str.push(s[i]);
    9. }
    10. string ans;
    11. while(str.size())
    12. {
    13. ans += str.top();
    14. str.pop();
    15. }
    16. reverse(ans.begin(), ans.end());
    17. return ans;
    18. }
    19. };

    第三题:2391. 收集垃圾的最少总时间 - 力扣(LeetCode)

    思路:模拟。因为每辆车都是从0开始出发,所以只需要找到每个垃圾的最后一个下标加上它们的前缀和就是每辆汽车的时间,每个垃圾收拾的次数都是一分钟,所以收拾垃圾的时间就是每个垃圾的次数和,最后将汽车的总时间和收拾垃圾的总时间加在一起就是总时间。

    代码

    1. class Solution {
    2. public:
    3. int garbageCollection(vector<string>& g, vector<int>& travel) {
    4. int ans = 0;
    5. int n = g.size();
    6. int a = 0, b = 0, c = 0;
    7. map<char, int> mp;
    8. for(int i = 0; i < n; i ++)
    9. {
    10. auto t = g[i];
    11. for(auto j : t)
    12. {
    13. mp[j] ++;
    14. if(j == 'M') a = i;
    15. else if(j == 'P') b = i;
    16. else c = i;
    17. }
    18. }
    19. for(int i = 1; i < n - 1; i ++) travel[i] += travel[i - 1];
    20. if(a != 0) a = travel[a - 1];
    21. if(b != 0) b = travel[b - 1];
    22. if(c != 0) c = travel[c - 1];
    23. // cout << a << " " << b << " " << c << endl;
    24. ans += a + b + c;
    25. for(auto [x, y] : mp) ans += y;
    26. return ans;
    27. }
    28. };

    第四题:2392. 给定条件下构造矩阵 - 力扣(LeetCode)

    思路:拓扑排序。因为有一个二维数组规定了关于行和列的先后顺序,可以用拓扑排序来求每行和每列的数字的前后顺序,通过这个先后的的顺序可以确定一个数的位置。拓扑的无法出现所有的就表示无法构造一个矩阵。

    代码

    1. const int N = 410, M = 10010;
    2. class Solution {
    3. public:
    4. int h1[N], e1[M], ne1[M], idx1;
    5. int h2[N], e2[M], ne2[M], idx2;
    6. int d1[N], d2[N];
    7. void add1(int a, int b)
    8. {
    9. e1[idx1] = b, ne1[idx1] = h1[a], h1[a] = idx1 ++;
    10. }
    11. void add2(int a, int b)
    12. {
    13. e2[idx2] = b, ne2[idx2] = h2[a], h2[a] = idx2 ++;
    14. }
    15. vector<vector<int>> buildMatrix(int k, vector>& r, vector>& c) {
    16. memset(h1, -1, sizeof h1);
    17. memset(h2, -1, sizeof h2);
    18. for(auto i : r)
    19. {
    20. int a = i[0], b = i[1];
    21. add1(a, b);
    22. d1[b] ++;
    23. }
    24. for(auto i : c)
    25. {
    26. int a = i[0], b = i[1];
    27. add2(a, b);
    28. d2[b] ++;
    29. }
    30. vector<int> res1, res2;
    31. queue<int> q1, q2;
    32. for(int i = 1; i <= k; i ++)
    33. {
    34. if(!d1[i]) q1.push(i);
    35. if(!d2[i]) q2.push(i);
    36. }
    37. while(q1.size())
    38. {
    39. auto p = q1.front(); q1.pop();
    40. res1.push_back(p);
    41. for(int i = h1[p]; i != -1; i = ne1[i])
    42. {
    43. int j = e1[i];
    44. d1[j] --;
    45. if(!d1[j]) q1.push(j);
    46. }
    47. }
    48. while(q2.size())
    49. {
    50. auto p = q2.front(); q2.pop();
    51. res2.push_back(p);
    52. for(int i = h2[p]; i != -1; i = ne2[i])
    53. {
    54. int j = e2[i];
    55. d2[j] --;
    56. if(!d2[j]) q2.push(j);
    57. }
    58. }
    59. if(res1.size() != k || res2.size() != k) return {};
    60. vector<vector<int>> ans(k, vector(k, 0));
    61. map<int, int> mp1, mp2;
    62. for(int i = 0; i < k; i ++)
    63. {
    64. mp1[res1[i]] = i;
    65. mp2[res2[i]] = i;
    66. }
    67. for(int i = 1; i <= k; i ++)
    68. {
    69. int x = mp1[i], y = mp2[i];
    70. ans[x][y] = i;
    71. }
    72. return ans;
    73. }
    74. };

  • 相关阅读:
    行列视(RCV)报表格式设计概述
    [资源推荐] 关于计算机毕设的方法论(重庆大学吕昱峰)
    【数据仓库设计基础(三)】数据集市
    基于51单片机的音乐盒播放器proteus仿真
    6-5、Python 数据类型-字典
    论<script> 标签可以直接写在 HTML 文件中的哪些位置?(可以将 <script> 标签直接插入到 HTML 文件的任何位置)
    【c++11特性】——static_cast,dynamic_cast,const_cast,reinterpret_cast解析
    李沐动手学深度学习V2-BERT预训练和代码实现
    用百度云怎么重装电脑系统
    信息登记小程序怎么做_扫码等级小程序制作步骤
  • 原文地址:https://blog.csdn.net/qq_56407679/article/details/126593168